/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
// in examtesterform.h
// #include "examgraphicsform.h"

void ExamTesterForm::init()
{
    GraphicForm = new ExamGraphicsForm(this);
    Tester = new ExamTester("sattest01.txt");
    textBrowser1->setText("<CENTER><H1>Math Tester Program</H1></CENTER>"
                          "<BR><BR>"
                          "<CENTER><H1>Cybernadian Computer Services</H1></CENTER>"
                          "<BR><BR>"
                          "<CENTER><H1>Click Start To Begin Exam</H1></CENTER>");

    GraphicForm->hide();
    _NextTestButton->show();
    _NextTestButton->setText("&Help");
    _GenerateButton->show();
    _ClearButton->hide();
    _QuitButton->show();
    _AnswerLabel->hide();
    _AnswerLineEdit->hide();
    _SubmitButton->setText("&Start");
    _ExamStarted = false;
    _ExamEnded = false;
    _ReviewExam = false;
    _ReviewStarted = false;
    _Restarted = false;
    _MathTutorialMode = false;
    _TutorialIndex = 0;

    _ProcPtr = new QProcess(this);
    _Executed = false;
    _HelpFileName = strcpy(new char[80], "mathtesterhelp.html");

    connect(_Bubble1, SIGNAL(clicked()), this, SLOT(ShowButton1()));
    connect(_Bubble2, SIGNAL(clicked()), this, SLOT(ShowButton2()));
    connect(_Bubble3, SIGNAL(clicked()), this, SLOT(ShowButton3()));
    connect(_Bubble4, SIGNAL(clicked()), this, SLOT(ShowButton4()));
    connect(_Bubble5, SIGNAL(clicked()), this, SLOT(ShowButton5()));

    connect(_ProcPtr, SIGNAL(started()),
            this, SLOT(ProcessStarted()));
    connect(_ProcPtr, SIGNAL(error(QProcess::ProcessError)),
            this, SLOT(ProcessError(QProcess::ProcessError)));
    connect(_ProcPtr, SIGNAL(finished(int, QProcess::ExitStatus)),
            this, SLOT(ProcessExited(int, QProcess::ExitStatus)));
}

/*****************************************************************************/
void ExamTesterForm::destroy()
{
    delete Tester;
    Tester = NULL;
    _Executed = false;
    delete[] _HelpFileName;
    _HelpFileName = NULL;
}

/*****************************************************************************/
void ExamTesterForm::ShowMathTutorial()
{
    char Buffer_[80];
    const char* NewFile_ = Tester->TutorialFileName(Buffer_);

    if (NewFile_ && Tester->Fexists(NewFile_))
    {
      Tester->ReadFile(NewFile_);
      _MathTutorialMode = true;
      _TutorialIndex = 0;
      ClearBoxes();

      _AnswerLabel->show();
      _AnswerLineEdit->show();
      _NextTestButton->hide();
      _GenerateButton->hide();

      _ReviewStarted = true;
      _SubmitButton->setText("&Previous");
      _ClearButton->setText("&Next");
      _SubmitButton->show();
      _ClearButton->show();
      SetReadOnlyBoxes(true);
      ShowTutorialExplanation();
    }
}

/*****************************************************************************/
void ExamTesterForm::GenerateExamQuestions()
{
  Tester->GenerateExam(MAX_QUESTIONS);

  char Buffer_[80];
  const char* NewFile_ = Tester->GeneralFileName(Buffer_);

  if (NewFile_ && Tester->Fexists(NewFile_))
  {
    Tester->ReadFile(NewFile_);
    StartExam();
  }
  else
  {
    _NextTestButton->setEnabled(false);
    _GenerateButton->setEnabled(false);
  }
}

/*****************************************************************************/
void ExamTesterForm::GenerateExam()
{
    QMessageBox msgBox(this);
      msgBox.setText("Tutorial for basic math concepts available.");
      msgBox.setInformativeText("Do you review basic math concepts before proceeding?");

    QPushButton *yesButton = msgBox.addButton(QMessageBox::Yes);
    QPushButton *noButton = msgBox.addButton(QMessageBox::No);

    msgBox.exec();

    if (msgBox.clickedButton() == yesButton)
      ShowMathTutorial();
    else
      GenerateExamQuestions();
}

/*****************************************************************************/
void ExamTesterForm::GetNextExam()
{
  if (!_ExamStarted)
    ExecuteHelpViewer();
  else
  {
    char Buffer_[80];
    const char* NewFile_ = Tester->NextFileName(Buffer_);
    const char* CurFile_ = Tester->GiveCurrentFile();

    if (NewFile_ && strcmp(NewFile_, CurFile_) != 0 && Tester->Fexists(NewFile_))
    {
      Tester->ReadFile(NewFile_);
      StartExam();
    }
    else
    {
      _NextTestButton->setEnabled(false);
      _GenerateButton->setEnabled(false);
    }
  }
}

/*****************************************************************************/
void ExamTesterForm::StartExam()
{
    _TutorialIndex = _Index = 0;
    _ExamStarted = true;
    _ExamEnded = false;
    
    _AnswerLabel->show();
    _AnswerLineEdit->show();
    _NextTestButton->hide();
    _GenerateButton->hide();
    _SubmitButton->setText("&Submit");
    _ClearButton->setText("&Clear");
    _ClearButton->show();
    _QuitButton->show();
    Tester->ClearResponses();
    ClearBoxes();
    ShowQuestion();
}

/*****************************************************************************/
void ExamTesterForm::ClearBoxes()
{
    _Bubble1->setChecked(false);
    _Bubble2->setChecked(false);
    _Bubble3->setChecked(false);
    _Bubble4->setChecked(false);
    _Bubble5->setChecked(false);
    _AnswerLineEdit->clear();
}

/*****************************************************************************/
void ExamTesterForm::ShowButton5()
{
  ShowButton(5);
}

/*****************************************************************************/
void ExamTesterForm::ShowButton4()
{
  ShowButton(4);
}

/*****************************************************************************/
void ExamTesterForm::ShowButton3()
{
  ShowButton(3);
}

/*****************************************************************************/
void ExamTesterForm::ShowButton2()
{
  ShowButton(2);
}

/*****************************************************************************/
void ExamTesterForm::ShowButton1()
{
  ShowButton(1);
}

/*****************************************************************************/
void ExamTesterForm::ShowButton(int Btn_)
{
    if (Btn_ == 1 && _Bubble1->isChecked())
    {
      ClearBoxes();
      _Bubble1->setChecked(true);
    }
    else if (Btn_ == 2 && _Bubble2->isChecked())
    {
      ClearBoxes();
      _Bubble2->setChecked(true);
    }
    else if (Btn_ == 3 && _Bubble3->isChecked())
    {
      ClearBoxes();
      _Bubble3->setChecked(true);
    }
    else if (Btn_ == 4 && _Bubble4->isChecked())
    {
      ClearBoxes();
      _Bubble4->setChecked(true);
    }
    else if (Btn_ == 5 && _Bubble5->isChecked())
    {
      ClearBoxes();
      _Bubble5->setChecked(true);
    }
}

/*****************************************************************************/
void ExamTesterForm::SetReadOnlyBoxes(bool Flag_)
{
    if (Flag_)
    {
      disconnect(_Bubble1, 0, this, 0);
      disconnect(_Bubble2, 0, this, 0);
      disconnect(_Bubble3, 0, this, 0);
      disconnect(_Bubble4, 0, this, 0);
      disconnect(_Bubble5, 0, this, 0);

      connect(_Bubble1, SIGNAL(clicked()), this, SLOT(ShowAnswer()));
      connect(_Bubble2, SIGNAL(clicked()), this, SLOT(ShowAnswer()));
      connect(_Bubble3, SIGNAL(clicked()), this, SLOT(ShowAnswer()));
      connect(_Bubble4, SIGNAL(clicked()), this, SLOT(ShowAnswer()));
      connect(_Bubble5, SIGNAL(clicked()), this, SLOT(ShowAnswer()));
      _AnswerLineEdit->setReadOnly(true);      
    }
    else
    {
      disconnect(_Bubble1, 0, this, 0);
      disconnect(_Bubble2, 0, this, 0);
      disconnect(_Bubble3, 0, this, 0);
      disconnect(_Bubble4, 0, this, 0);
      disconnect(_Bubble5, 0, this, 0);

      connect(_Bubble1, SIGNAL(clicked()), this, SLOT(ShowButton1()));
      connect(_Bubble2, SIGNAL(clicked()), this, SLOT(ShowButton2()));
      connect(_Bubble3, SIGNAL(clicked()), this, SLOT(ShowButton3()));
      connect(_Bubble4, SIGNAL(clicked()), this, SLOT(ShowButton4()));
      connect(_Bubble5, SIGNAL(clicked()), this, SLOT(ShowButton5()));
      _AnswerLineEdit->setReadOnly(false);
    }
}

/*****************************************************************************/
void ExamTesterForm::ShowAnswer()
{
    int Parts_, x;
    int Index_ = _MathTutorialMode ? _TutorialIndex:_Index;
    const char* Buffer_ = Tester->GiveAnswer(Index_, Parts_);
    char Answer_[20];

    ClearBoxes();    
    memset(Answer_, 0, 20);
    for (x = 0; x < Parts_; x++)
      Answer_[x] = Buffer_[Index_ + x];

    if (!_MathTutorialMode && Tester->GiveChoices(_Index))
    {
      if (Answer_[0] == 'A')
        _Bubble1->setChecked(true);
      else if (Answer_[0] == 'B')
        _Bubble2->setChecked(true);
      else if (Answer_[0] == 'C')
        _Bubble3->setChecked(true);
      else if (Answer_[0] == 'D')
        _Bubble4->setChecked(true);
      else if (Answer_[0] == 'E')
        _Bubble5->setChecked(true);
      else
        ClearBoxes();
    }
    else
      _AnswerLineEdit->setText(QString(Answer_));
}

/*****************************************************************************/
void ExamTesterForm::ShowBubbles(bool Visible_)
{
    _Bubble1->setShown(Visible_);
    _Bubble2->setShown(Visible_);
    _Bubble3->setShown(Visible_);
    _Bubble4->setShown(Visible_);
    _Bubble5->setShown(Visible_);
    _AnswerLineEdit->setShown(!Visible_);
    _AnswerLabel->setShown(!Visible_);
}

/*****************************************************************************/
void ExamTesterForm::ClearPushed()
{
    if (_ReviewStarted || _MathTutorialMode)
    {
      if (_MathTutorialMode)
      {
        _TutorialIndex++;

        if (_TutorialIndex < Tester->MaxQuestions())
          ShowTutorialExplanation();
        else
        {
          StopReview();
          GenerateExamQuestions();
        }
      }
      else
      {
        _Index++;

        if (_Index < Tester->MaxQuestions())
          ShowExplanation();
        else
          StopReview();
      }
    }
    else if (_ReviewExam)
    {
      StopReview();
      StartExam();
    }
    else if (!_ExamStarted && _Restarted)
    {
      _TutorialIndex = _Index = 0;
      _ExamStarted = false;
      _ExamEnded = false;
      _ReviewExam = true;
      
      GraphicForm->Reset();
      GraphicForm->hide();
      _QuitButton->show();
      ClearBoxes();
      ShowBubbles(true);
      _AnswerLineEdit->setShown(true);
      _AnswerLabel->setShown(true);

      if (_MathTutorialMode)
        ShowMathTutorial();
      else
        ReviewExam();
    }
    else
      ClearBoxes();
}

/*****************************************************************************/
void ExamTesterForm::QuitExam()
{
    _ExamEnded = true;
    _AnswerLabel->hide();
    _AnswerLineEdit->hide();
    _NextTestButton->show();
    _GenerateButton->show();

    #if EXAMTESTER_GUI_DEBUG2
      QMessageBox::critical(0, "debug", QString(_ExamStarted ? "es=true\n":"es=false\n") +
                                        QString(_ExamEnded ? "ee=true\n":"ee=false\n") +
                                        QString(_ReviewStarted ? "rs=true\n":"rs=false\n") +
                                        QString(_ReviewExam ? "re=true\n":"re=false\n"), "ok");
    #endif

    if (_ReviewStarted || _MathTutorialMode)
      StopReview();
    else if (_ExamStarted)
      ShowNextQuestion();
    else
      close();
}

/*****************************************************************************/
void ExamTesterForm::StopReview()
{
    _TutorialIndex = _Index = 0;
    _MathTutorialMode = false;
    _Restarted = true;
    _ExamStarted = false;
    _ExamEnded = false;
    _ReviewExam = false;
    _ReviewStarted = false;
    _SubmitButton->setText("&Start");    
    _ClearButton->setText("&Review");
    _QuitButton->show();    
    SetReadOnlyBoxes(false);
    ShowSummary();
    ShowBubbles(true);
    ClearBoxes();            
    _AnswerLineEdit->setShown(true);
    _AnswerLabel->setShown(true);
    GraphicForm->Reset();
    GraphicForm->hide();
    _AnswerLabel->hide();
    _AnswerLineEdit->hide();
    _NextTestButton->show();
    _GenerateButton->show();
}

/*****************************************************************************/
void ExamTesterForm::ReviewExam()
{
    _AnswerLabel->show();
    _AnswerLineEdit->show();
    _NextTestButton->hide();
    _GenerateButton->hide();

    _ReviewStarted = true;
    _SubmitButton->setText("&Previous");
    _ClearButton->setText("&Next");
    _SubmitButton->show();
    _ClearButton->show();
    SetReadOnlyBoxes(true);
    ShowExplanation();
}

/*****************************************************************************/
void ExamTesterForm::ShowTutorialExplanation()
{
    const char* SectionName_ = Tester->GiveSectionName(_TutorialIndex);

    if (SectionName_)
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Section: ") +
                            QString(SectionName_) + QString("</U></B><BR>\n") +
                            QString("<B><U>Question #") + QString::number(_TutorialIndex + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_TutorialIndex)));
    else
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Question #") +
                            QString::number(_TutorialIndex + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_TutorialIndex)));

    textBrowser1->setText(textBrowser1->text() +
                          QString("\n<BR><B><U>Solution:</U></B><BR>\n<P>") +
                          QString(Tester->GiveExplanation(_TutorialIndex)));

    ShowAnswer();

    if (Tester->GiveQGraphic(_TutorialIndex))
    {
      GraphicForm->SetGraphicFile(Tester->GiveQGraphic(_TutorialIndex));
      GraphicForm->show();
    }
    else
    {
      GraphicForm->Reset();
      GraphicForm->hide();
    }
}

/*****************************************************************************/
void ExamTesterForm::ShowExplanation()
{
    const char* SectionName_ = Tester->GiveSectionName(_Index);

    if (SectionName_)
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Section: ") +
                            QString(SectionName_) + QString("</U></B><BR>\n") +
                            QString("<B><U>Question #") + QString::number(_Index + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_Index)));    
    else
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Question #") +
                            QString::number(_Index + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_Index)));

    textBrowser1->setText(textBrowser1->text() +
                          QString("\n<BR><B><U>Solution:</U></B><BR>\n<P>") +
                          QString(Tester->GiveExplanation(_Index)));

    if (Tester->GiveChoices(_Index))
    {
      textBrowser1->setText(textBrowser1->text() +
                            QString("\n<BR><P>") +
                            QString(Tester->GiveChoices(_Index)) +
                            QString("\n</FONT>"));
      ShowBubbles(true);
    }
    else
      ShowBubbles(false);

    ShowAnswer();
    
    if (Tester->GiveQGraphic(_Index))
    {
      GraphicForm->SetGraphicFile(Tester->GiveAGraphic(_Index));
      GraphicForm->show();
    }
    else
    {
      GraphicForm->Reset();
      GraphicForm->hide();
    }    
}

/*****************************************************************************/
void ExamTesterForm::ShowQuestion()
{
    const char* SectionName_ = Tester->GiveSectionName(_Index);

    ClearBoxes();
    if (SectionName_)
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Section: ") +
                            QString(SectionName_) + QString("</U></B><BR>\n") +
                            QString("<B><U>Question #") + QString::number(_Index + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_Index)));    
    else
      textBrowser1->setText(QString("<FONT SIZE=4><B><U>Question #") +
                            QString::number(_Index + 1) +
                            QString("</U></B><BR>\n<P>") +
                            QString(Tester->GiveQuestion(_Index)));
    
    if (Tester->GiveChoices(_Index))
    {
      textBrowser1->setText(textBrowser1->text() +
                            QString("\n<BR><P>") +
                            QString(Tester->GiveChoices(_Index)) +
                            QString("\n</FONT>"));
      ShowBubbles(true);
    }
    else
      ShowBubbles(false);

    if (Tester->GiveQGraphic(_Index))
    {
      GraphicForm->SetGraphicFile(Tester->GiveQGraphic(_Index));
      GraphicForm->show();
    }
    else
    {
      GraphicForm->Reset();
      GraphicForm->hide();
    }
}

/*****************************************************************************/
void ExamTesterForm::ShowSummary()
{
    textBrowser1->setText(Tester->GiveSummary());
}

/*****************************************************************************/
char ExamTesterForm::GetChoice() const
{
    return
    (
      (_Bubble1->isChecked() && !_Bubble2->isChecked() && !_Bubble3->isChecked() &&
       !_Bubble4->isChecked() && !_Bubble5->isChecked()) ? 'A':
      (!_Bubble1->isChecked() && _Bubble2->isChecked() && !_Bubble3->isChecked() &&
       !_Bubble4->isChecked() && !_Bubble5->isChecked()) ? 'B':
      (!_Bubble1->isChecked() && !_Bubble2->isChecked() && _Bubble3->isChecked() &&
       !_Bubble4->isChecked() && !_Bubble5->isChecked()) ? 'C':
      (!_Bubble1->isChecked() && !_Bubble2->isChecked() && !_Bubble3->isChecked() &&
       _Bubble4->isChecked() && !_Bubble5->isChecked()) ? 'D':
      (!_Bubble1->isChecked() && !_Bubble2->isChecked() && !_Bubble3->isChecked() &&
       !_Bubble4->isChecked() && _Bubble5->isChecked()) ? 'E':' '
    );
}

/*****************************************************************************/
void ExamTesterForm::SendResponse()
{
    if (Tester->GiveChoices(_Index))
    {
      #if EXAMTESTER_GUI_DEBUG1
        QChar Choice_ = GetChoice();
        QMessageBox::critical(0, "debug", QString(Choice_), "ok");
      #endif
      
      Tester->SetResponse(_Index, GetChoice());
    }
    else
    {
      QString Contents_ = _AnswerLineEdit->text();
      uint Len_ = Contents_.length();

      char Choice1_ = (Len_ > 0) ? (Contents_.ascii())[0]:' ';
      char Choice2_ = (Len_ > 1) ? (Contents_.ascii())[1]:' ';
      char Choice3_ = (Len_ > 2) ? (Contents_.ascii())[2]:' ';
      char Choice4_ = (Len_ > 3) ? (Contents_.ascii())[3]:' ';

      char Choice5_ = (Len_ > 4) ? (Contents_.ascii())[4]:' ';
      char Choice6_ = (Len_ > 5) ? (Contents_.ascii())[5]:' ';
      char Choice7_ = (Len_ > 6) ? (Contents_.ascii())[6]:' ';
      char Choice8_ = (Len_ > 7) ? (Contents_.ascii())[7]:' ';

      char Buffer_[80];
      bool BufSet_ = false;

      if (Len_ > 8)
      {
        strcpy(Buffer_, Contents_.ascii());
        BufSet_ = true;
      }

      Tester->SetResponse(_Index, Choice1_, Choice2_, Choice3_, Choice4_,
                          Choice5_, Choice6_, Choice7_, Choice8_,
                          BufSet_ ? Buffer_:NULL, Len_);
    }
}

/*****************************************************************************/
void ExamTesterForm::ShowNextQuestion()
{
    if (_ExamStarted && !_ReviewStarted)
    {
      if (_ExamEnded)
      {
        Tester->MarkExam();
        ShowSummary();
        _TutorialIndex = _Index = 0;
        _ExamStarted = false;
        _ExamEnded = false;
        _ReviewExam = true;
        GraphicForm->Reset();
        GraphicForm->hide();
        _QuitButton->show();
        _ClearButton->setText("Re&start");
        _SubmitButton->setText("&Review");
        ClearBoxes();
        ShowBubbles(true);
        _AnswerLineEdit->setShown(true);
        _AnswerLabel->setShown(true);

        _NextTestButton->show();
        _GenerateButton->show();
        _AnswerLineEdit->hide();
        _AnswerLabel->hide();
      }
      else
      {
        SendResponse();      
        _Index++;
        
        if (_Index < Tester->MaxQuestions())
          ShowQuestion();
        else
          QuitExam();
      }
    }
    else if (_ReviewExam || _MathTutorialMode)
    {
      if (_ReviewStarted || _MathTutorialMode)
      {
        if (_MathTutorialMode)
        {
          if (_TutorialIndex > 0)
          {
            _TutorialIndex--;
            ShowTutorialExplanation();
          }
        }
        else
        {
          if (_Index > 0)
          {
            _Index--;
            ShowExplanation();
          }
        }
      }
      else
      {
        if (_MathTutorialMode)
          ShowMathTutorial();
        else
          ReviewExam();
      }
    }
    else
    {
      _NextTestButton->setText("Next Exam");
      _NextTestButton->hide();
      StartExam();
    }
}

/*****************************************************************************/
void ExamTesterForm::ProcessError(QProcess::ProcessError Error_)
{
    if (Error_)
    {
      QMessageBox::critical(0, tr("Fatal Error"),
                            tr("The help viewer program has crashed"),
                            tr("Quit"));
    }
    else
    {
      QMessageBox::critical(0, tr("Fatal Error"),
                            tr("Could not start help viewer program"),
                            tr("Quit"));
    }

    done(1);
}

/*****************************************************************************/
void ExamTesterForm::ProcessStarted()
{
    _Executed = true;
}

/*****************************************************************************/
void ExamTesterForm::ProcessExited(int exitCode, QProcess::ExitStatus exitStatus)
{
    if (exitStatus == QProcess::NormalExit)
    {
      if (exitCode)
      {
        QMessageBox::information(0, tr("Program Ended"),
                           tr("The help viewer program: viewer.exe has finished successfully"),
                           tr("Quit"));
        _Executed = false;
      }
    }
    else if (exitStatus == QProcess::CrashExit)
    {
      QMessageBox::critical(0, tr("Fatal Error"),
                            tr("The help viewer program: hrtxtparse.exe has crashed"),
                            tr("Quit"));
      done(1);
    }
}

/*****************************************************************************/
void ExamTesterForm::ExecuteHelpViewer()
{
  if (_Executed)
    return;

  QString ProgName_ = "viewhelp.exe";

  _ProcPtr->start(ProgName_, QIODevice::ReadWrite);
  _Executed = false;
}

/*****************************************************************************/
