#ifndef COMMON_H
#define COMMON_H

#include "testerheaders.h"

class CommonFncs
{
  private:  
    bool _WithMsg;
    bool _WithLog;
    int _MaxLineCnt;
    int* _LineCnt;
    int* _Set;

    enum { DEFAULT_MAX_LINE_CNT = 20000 };

  public:
    CommonFncs();
    ~CommonFncs();

    int GetLineCount() const;
    int GetMaxLineCount() const;
    void SetTraceWithMsg(bool Flag_);
    void SetTraceWithLog(bool Flag_, int MaxLineCnt_, int* LineCnt_);
    void StartTrace(QFile& DbgFile_, const QString& Caption_, const QString& FncName_, const QString& Args_);
    void EndTrace(QFile& DbgFile_, const QString & Caption_, const QString & FncName_, const QString & Args_);
    void ArgTrace(QFile& DbgFile_, const QString & Caption_, const QString & ArgName_, const QString & Args_);
    bool OpenTextFile(const QString& Name_, QFlags<QIODevice::OpenModeFlag> Mode_, QFile& File_, const QString& AppName_);
    bool OpenBinFile(const QString& Name_, QFlags<QIODevice::OpenModeFlag> Mode_, QFile& File_, const QString& AppName_);
    void Error(const QFile& File_, const QString& Msg_, const QString& AppName_);
    void ioError(const QFile& File_, const QString& Msg_, const QString& AppName_);
    void CloseBlock(QByteArray& Block_, QDataStream& out, Q3Socket& Socket_);
    Q_UINT8 SendSignal(Q_UINT8 Signal_, QDataStream& out);
    QString& AppendPathToName(QString& Result_, const QString & Path_, const QString & Filename_);
    void CopyBinFile(const QString& SrceDir_, const QString& DestDir_, const QString& Name_);
    void CopyTxtFile(const QString& SrceDir_, const QString& DestDir_, const QString& Name_);
    void CopyBinFileToFile(const QString& SrceDir_, const QString& DestDir_,
                           const QString& SrceName_, const QString& DestName_);
    void CopyTxtFileToFile(const QString& SrceDir_, const QString& DestDir_,
                           const QString& SrceName_, const QString& DestName_);    
    static QString RootPath();
    static QString& SecsToHms(QString& Str_, Q_ULONG Secs_);
};

#endif
