#include "tester.h"

/******************************************************************************/
ExamTester::ExamTester():
_Max(0),
_Sections(0),
_Parts(0),
_SectionStart(0),
_SubScore(0),
_Questions(0),
_Choices(0),
_QGraphicFile(0),
_AGraphicFile(0),
_Explanations(0),
_SectionName(0),
_Answers(0),
_Response(0),
_Corrects(0),
_Score(0),
_Summary(0),
_CurrentFile(NULL)
{
  _Generator = new ExamGenerator();
}

/******************************************************************************/
ExamTester::ExamTester(int Max_):
_Max(Max_),
_Sections(0),
_Parts(new int[Max_]),
_SectionStart(new int[Max_]),
_SubScore(new int*[Max_]),
_Questions(new char*[Max_]),
_Choices(new char*[Max_]),
_QGraphicFile(new char*[Max_]),
_AGraphicFile(new char*[Max_]),
_Explanations(new char*[Max_]),
_SectionName(new char*[Max_]),
_Answers(new char[Max_ * 16 + 1]),
_Response(new char[Max_ * 16 + 1]),
_Corrects(0),
_Score(0),
_Summary(0),
_CurrentFile(NULL)
{
  int x, y;
  for (x = y = 0; x < _Max; x++)
  {
    _Parts[x] = 1;
    _SectionStart[x] = 0;
    _SubScore[x] = new int[2];
    memset(_SubScore[x], 0, sizeof(int) * 2);
    _Questions[x] = NULL;
    _Choices[x] = NULL;    
    _QGraphicFile[x] = NULL;
    _AGraphicFile[x] = NULL;
    _Explanations[x] = NULL;
    _SectionName[x] = NULL;
    y = x * 16;
    _Answers[y] = _Answers[y+1] = _Answers[y+2] = _Answers[y+3] =
    _Answers[y+4] = _Answers[y+5] = _Answers[y+6] = _Answers[y+7] = ' ';
    _Answers[y+8] = _Answers[y+9] = _Answers[y+10] = _Answers[y+11] =
    _Answers[y+12] = _Answers[y+13] = _Answers[y+14] = _Answers[y+15] = ' ';

    _Response[y] = _Response[y+1] = _Response[y+2] = _Response[y+3] =
    _Response[y+4] = _Response[y+5] = _Response[y+6] = _Response[y+7] = ' ';
    _Response[y+8] = _Response[y+9] = _Response[y+10] = _Response[y+11] =
    _Response[y+12] = _Response[y+13] = _Response[y+14] = _Response[y+15] = ' ';
  }

  _Answers[x*16] = 0;
  _Response[x*16] = 0;
  _Generator = new ExamGenerator();
}

/******************************************************************************/
ExamTester::ExamTester(const char* ExamFile_):
_Max(0),
_Sections(0),
_Parts(0),
_SectionStart(0),
_SubScore(0),
_Questions(0),
_Choices(0),
_QGraphicFile(0),
_AGraphicFile(0),
_Explanations(0),
_SectionName(0),
_Answers(0),
_Response(0),
_Corrects(0),
_Score(0),
_Summary(0),
_CurrentFile(NULL)
{
  _Generator = new ExamGenerator();
  ReadFromFile(ExamFile_);
}

/******************************************************************************/
ExamTester::~ExamTester()
{
  Clear();
}

/******************************************************************************/
void ExamTester::Clear()
{
  int x;
  for (x = 0; x < _Max; x++)
  {
    delete[] _Questions[x];
    delete[] _Choices[x];
    delete[] _QGraphicFile[x];
    delete[] _AGraphicFile[x];
    delete[] _Explanations[x];
    delete[] _SectionName[x];
    delete[] _SubScore[x];
  }

  delete[] _Parts;
  delete[] _SectionStart;
  delete[] _SubScore;  
  delete[] _Questions;
  delete[] _Choices;
  delete[] _QGraphicFile;
  delete[] _AGraphicFile;
  delete[] _Explanations;
  delete[] _SectionName;
  delete[] _Answers;
  delete[] _Response;
  delete[] _Summary;
  delete[] _CurrentFile;

  _Max = 0;
  _Sections = 0;
  _Parts = 0;
  _SectionStart = 0;
  _SubScore = 0;
  _Questions = 0;
  _Choices = 0;
  _QGraphicFile = 0;
  _AGraphicFile = 0;
  _Explanations = 0;
  _SectionName = 0;
  _Answers = 0;
  _Response = 0;
  _Corrects = 0;
  _Score = 0;
  _Summary = 0;
  _CurrentFile = NULL;
}

/******************************************************************************/
void ExamTester::MakeExam(int Max_)
{
  if (_Max)
    Clear();

  _Max = Max_;
  _Sections = 0;
  _Parts = new int[Max_];
  _SectionStart = new int[Max_];
  _SubScore = new int*[Max_];
  _Questions = new char*[Max_];
  _Choices = new char*[Max_];
  _QGraphicFile = new char*[Max_];
  _AGraphicFile = new char*[Max_];
  _Explanations = new char*[Max_];
  _SectionName = new char*[Max_];  
  _Answers = new char[Max_ * 16 + 1];
  _Response = new char[Max_ * 16 + 1];

  int x, y;
  for (x = 0; x < _Max; x++)
  {
    _Parts[x] = 1;
    _SectionStart[x] = 0;
    _SubScore[x] = new int[2];
    memset(_SubScore[x], 0, sizeof(int) * 2);
    _Questions[x] = NULL;
    _Choices[x] = NULL;
    _QGraphicFile[x] = NULL;
    _AGraphicFile[x] = NULL;
    _Explanations[x] = NULL;
    _SectionName[x] = NULL;
    y = x * 16;
    _Answers[y] = _Answers[y+1] = _Answers[y+2] = _Answers[y+3] =
    _Answers[y+4] = _Answers[y+5] = _Answers[y+6] = _Answers[y+7] = ' ';
    _Answers[y+8] = _Answers[y+9] = _Answers[y+10] = _Answers[y+11] =
    _Answers[y+12] = _Answers[y+13] = _Answers[y+14] = _Answers[y+15] = ' ';

    _Response[y] = _Response[y+1] = _Response[y+2] = _Response[y+3] =
    _Response[y+4] = _Response[y+5] = _Response[y+6] = _Response[y+7] = ' ';
    _Response[y+8] = _Response[y+9] = _Response[y+10] = _Response[y+11] =
    _Response[y+12] = _Response[y+13] = _Response[y+14] = _Response[y+15] = ' ';
  }

  _Answers[x*16] = 0;
  _Response[x*16] = 0;
}

/******************************************************************************/
void ExamTester::GenerateExam(int Max_)
{
    int x, y;
    int len;
    ofstream Fout_("GeneratedProblems.txt", ios::out);

    _Generator->GenerateProblems(Max_, ExamGenerator::MIXED, 4);
    _Generator->SetDivRemainderPercentage(50);
    const char* Question_;
    const char* Answer_;

    Fout_ <<"50" <<endl <<endl;
    Fout_ <<"#Section: Basic Arithmetic" <<endl;

    for (x = 1; !_Generator->AllQuestionsDone(); x++)
    {
      Question_ = _Generator->GiveQuestion();

      Fout_ <<endl <<"#" <<x <<endl;
      Fout_ <<"1" <<endl;
      Fout_ <<Question_ <<endl;
      Fout_ <<"0\n1\n";

      Answer_ = _Generator->IsFraction() ? _Generator->FinalFraction():_Generator->FinalNumber();
      len = strlen(Answer_);
      Fout_ <<Answer_ <<endl;

      Fout_ <<"0\n0\n";
      Fout_ <<len <<endl;

      for (y = 0; y < len; y++)
        Fout_ <<Answer_[y] <<endl;
    }

    Fout_.close();
}

/******************************************************************************/
const char* ExamTester::TutorialFileName(char* Buffer_) const
{
  strcpy(Buffer_, "MathTutorial.txt");
  return Buffer_;
}

/******************************************************************************/
const char* ExamTester::GeneralFileName(char* Buffer_) const
{
  strcpy(Buffer_, "GeneratedProblems.txt");
  return Buffer_;
}

/******************************************************************************/
const char* ExamTester::NextFileName(char* Buffer_)
{
  if (!_CurrentFile)
    return NULL;
  else if (strcmp(_CurrentFile, "GeneratedProblems.txt") == 0 ||
           strcmp(_CurrentFile, "MathTutorial.txt") == 0)
  {
    delete[] _CurrentFile;
    _CurrentFile = strcpy(new char[strlen("sattest00.txt") + 1], "sattest00.txt");
  }

  size_t len = strlen(_CurrentFile);
  size_t tens = _CurrentFile[len - 6] - '0';
  size_t num = _CurrentFile[len - 5] - '0';

  ++num;
  if (num > 9)
  {
    ++tens;
    num = 0;

    if (tens > 9)
      return NULL;
  }

  strcpy(Buffer_, _CurrentFile);
  Buffer_[len - 6] = tens + '0';
  Buffer_[len - 5] = num + '0';

  return Buffer_;
}

/****************************************************************************/
int ExamTester::Fexists(const char* Fname_) const
{
  FILE* fp;
  fp = fopen(Fname_, "r");
  if (fp==0) return 0;
  fclose(fp);
  return 1;
}

/******************************************************************************/
void ExamTester::ReadFile(const char* ExamFile_)
{
  Clear();
  ReadFromFile(ExamFile_);
}

/******************************************************************************/
void ExamTester::TestRead()
{
  int x, y, z, i;
  for (x = i = 0; x < _Max; x++)
  {
    if (i < _Sections && x == _SectionStart[i])
    {
      cout <<_SectionName[i] <<endl;
      ++i;
    }
    
    cout <<_Questions[x];
    if (_Choices[x])
      cout <<_Choices[x];
    cout <<_Explanations[x];
    if (_QGraphicFile[x])
      cout <<_QGraphicFile[x] <<endl;
    if (_AGraphicFile[x])
      cout <<_AGraphicFile[x] <<endl;
    cout <<_Parts[x] <<endl;
    
    y = x * 16;
    for (z = 0; z < _Parts[x]; z++)
      cout <<_Answers[y+z] <<endl;
  }
}

/******************************************************************************/
// Format of data file:
// xx : total number of questions
// aa : total 128 char lines in question
// ----- question lines
// bb : total 128 char lines in explanation
// ----- explanation lines
// 0 : no graphic file OR <graph file name>
// <answer char>
//
void ExamTester::ReadFromFile(const char* ExamFile_, int HtmlFormat_)
{
  int Lines_ = 0;
  int Len_ = 256;
  char Buffer_[256];
  ifstream Fin_(ExamFile_, ios::in);
  char NewLine_[8];

  delete[] _CurrentFile;
  _CurrentFile = strcpy(new char[strlen(ExamFile_) + 1], ExamFile_);

  if (HtmlFormat_)
    strcpy(NewLine_, "<BR>\n");
  else
    strcpy(NewLine_, "\n");

  if (Fin_.good())
  {
    Fin_.getline(Buffer_, Len_);
    _Max = atoi(Buffer_);

    _Sections = 0;
    _Parts = new int[_Max];
    _SectionStart = new int[_Max];
    _SubScore = new int*[_Max];
    _Questions = new char*[_Max];
    _Choices = new char*[_Max];
    _QGraphicFile = new char*[_Max];
    _AGraphicFile = new char*[_Max];
    _Explanations = new char*[_Max];
    _SectionName = new char*[_Max];
    _Answers = new char[_Max * 16 + 1];
    _Response = new char[_Max * 16 + 1];

    int x, y, i;
    for (x = 0; x < _Max; x++)
    {
      _Parts[x] = 1;
      _SectionStart[x] = 0;
      _SubScore[x] = new int[2];
      memset(_SubScore[x], 0, sizeof(int) * 2);
      _Questions[x] = NULL;
      _Choices[x] = NULL;
      _QGraphicFile[x] = NULL;
      _AGraphicFile[x] = NULL;
      _Explanations[x] = NULL;
      _SectionName[x] = NULL;
      y = x * 16;
      _Answers[y] = _Answers[y+1] = _Answers[y+2] = _Answers[y+3] =
      _Answers[y+4] = _Answers[y+5] = _Answers[y+6] = _Answers[y+7] = ' ';
      _Answers[y+8] = _Answers[y+9] = _Answers[y+10] = _Answers[y+11] =
      _Answers[y+12] = _Answers[y+13] = _Answers[y+14] = _Answers[y+15] = ' ';

      _Response[y] = _Response[y+1] = _Response[y+2] = _Response[y+3] =
      _Response[y+4] = _Response[y+5] = _Response[y+6] = _Response[y+7] = ' ';
      _Response[y+8] = _Response[y+9] = _Response[y+10] = _Response[y+11] =
      _Response[y+12] = _Response[y+13] = _Response[y+14] = _Response[y+15] = ' ';
    }

    _Answers[x*16] = 0;
    _Response[x*16] = 0;
    x = 0;

    while (!Fin_.eof())
    {
      Fin_.getline(Buffer_, Len_);
      for (i = strlen(Buffer_); i && isspace(Buffer_[i - 1]); i--);
      Buffer_[i] = 0;
      for (i = 0; isspace(Buffer_[i]); i++);
      if (i) memmove(Buffer_, &Buffer_[i], strlen(&Buffer_[i]) + 1);

      if (!strlen(Buffer_))
        continue;
      else if (Buffer_[0] == '#')
      {
        if (isdigit(Buffer_[1]))
          continue;
        else if (strlen(Buffer_) > 9 && strncmp(Buffer_, "#Section:", 9) == 0)
        {
          _SectionName[_Sections] = strcpy(new char[strlen(&Buffer_[9]) + 1], &Buffer_[9]);
          _SectionStart[_Sections] = x;
          _Sections++;
          continue;
        }
      }
      
      Lines_ = atoi(Buffer_);
      _Questions[x] = new char[128 * Lines_];
      _Questions[x][0] = 0;

      while (Lines_)
      {
        Fin_.getline(Buffer_, Len_);
        for (i = strlen(Buffer_); i && isspace(Buffer_[i - 1]); i--);
        Buffer_[i] = 0;
        for (i = 0; isspace(Buffer_[i]); i++);
        if (i) memmove(Buffer_, &Buffer_[i], strlen(&Buffer_[i]) + 1);        
        if (strlen(Buffer_) == 1 && Buffer_[0] == '|')
          strcat(_Questions[x], NewLine_);
        else
          strcat(_Questions[x], Buffer_);
        strcat(_Questions[x], NewLine_);
        --Lines_;
      }

      Fin_.getline(Buffer_, Len_);
      Lines_ = atoi(Buffer_);
      
      if (Lines_)
      {
        _Choices[x] = new char[128 * Lines_];
        _Choices[x][0] = 0;

        while (Lines_)
        {
          Fin_.getline(Buffer_, Len_);
          strcat(_Choices[x], Buffer_);
          strcat(_Choices[x], NewLine_);
          --Lines_;
        }
      }
      
      Fin_.getline(Buffer_, Len_);
      Lines_ = atoi(Buffer_);
      _Explanations[x] = new char[128 * Lines_];
      _Explanations[x][0] = 0;

      while (Lines_)
      {
        Fin_.getline(Buffer_, Len_);
        for (i = strlen(Buffer_); i && isspace(Buffer_[i - 1]); i--);
        Buffer_[i] = 0;
        for (i = 0; isspace(Buffer_[i]); i++);
        if (i) memmove(Buffer_, &Buffer_[i], strlen(&Buffer_[i]) + 1);        
        if (strlen(Buffer_) == 1 && Buffer_[0] == '|')
          strcat(_Explanations[x], NewLine_);
        else
          strcat(_Explanations[x], Buffer_);
        strcat(_Explanations[x], NewLine_);
        --Lines_;
      }

      Fin_.getline(Buffer_, Len_);
      if (strlen(Buffer_) == 1 && Buffer_[0] == '0')
        _QGraphicFile[x] = NULL;
      else
        _QGraphicFile[x] = strcpy(new char[strlen(Buffer_) + 1], Buffer_);

      Fin_.getline(Buffer_, Len_);
      if (strlen(Buffer_) == 1 && Buffer_[0] == '0')
        _AGraphicFile[x] = NULL;
      else
        _AGraphicFile[x] = strcpy(new char[strlen(Buffer_) + 1], Buffer_);
      
      Fin_.getline(Buffer_, Len_);
      _Parts[x] = atoi(Buffer_);

      y = x * 16;
      for (i = 0; i < _Parts[x]; i++)
      {
        Fin_.getline(Buffer_, Len_);      
        _Answers[y+i] = Buffer_[0];
      }
      
      x++;
      if (x >= _Max)
        break;
    }
  }

  Fin_.close();
  #if EXAMTESTER_DEBUG_1
    TestRead();
  #endif
}

/******************************************************************************/
void ExamTester::SetChoices(int Index_, char* Choices_)
{
  delete[] _Choices[Index_];
  _Choices[Index_] = strcpy(new char[strlen(Choices_) + 1], Choices_);
}

/******************************************************************************/
void ExamTester::SetQuestion(int Index_, char* Question_)
{
  delete[] _Questions[Index_];
  _Questions[Index_] = strcpy(new char[strlen(Question_) + 1], Question_);
}

/******************************************************************************/
void ExamTester::SetExplanation(int Index_, char* Explain_)
{
  delete[] _Explanations[Index_];
  _Explanations[Index_] = strcpy(new char[strlen(Explain_) + 1], Explain_);
}

/******************************************************************************/
void ExamTester::SetAnswer(int Index_, char Choice1_, char Choice2_, char Choice3_, char Choice4_, char Choice5_, char Choice6_, char Choice7_, char Choice8_, char* Choicex_, int Len_)
{
  int Parts_ = (Choice4_ == ' ') ? ((Choice3_ == ' ') ? ((Choice2_ == ' ') ? (Choice1_ == ' ' ? Len_:1):2):3):4;
  _Parts[Index_] = Parts_;
  
  int x = 0;
  Index_ *= 16;

  _Answers[Index_] = Choice1_;
  _Answers[Index_+1] = Choice2_;
  _Answers[Index_+2] = Choice3_;
  _Answers[Index_+3] = Choice4_;

  _Answers[Index_+4] = Choice5_;
  _Answers[Index_+5] = Choice6_;
  _Answers[Index_+6] = Choice7_;
  _Answers[Index_+7] = Choice8_;

  if (Len_ > 8)
    for (x = 8; x < 16; x++)
      _Answers[Index_+x] = Choicex_[x];
}

/******************************************************************************/
void ExamTester::SetResponse(int Index_, char Choice1_, char Choice2_, char Choice3_, char Choice4_, char Choice5_, char Choice6_, char Choice7_, char Choice8_, char* Choicex_, int Len_)
{
  int x = 0;
  Index_ *= 16;

  _Response[Index_] = Choice1_;
  _Response[Index_+1] = Choice2_;
  _Response[Index_+2] = Choice3_;
  _Response[Index_+3] = Choice4_;

  _Response[Index_+4] = Choice5_;
  _Response[Index_+5] = Choice6_;
  _Response[Index_+6] = Choice7_;
  _Response[Index_+7] = Choice8_;

  if (Len_ > 8)
    for (x = 8; x < 16; x++)
      _Response[Index_+x] = Choicex_[x];
}

/******************************************************************************/
void ExamTester::SetQGraphicFile(int Index_, char* File_)
{
  delete[] _QGraphicFile[Index_];
  _QGraphicFile[Index_] = strcpy(new char[strlen(File_) + 1], File_);
}

/******************************************************************************/
void ExamTester::SetAGraphicFile(int Index_, char* File_)
{
  delete[] _AGraphicFile[Index_];
  _AGraphicFile[Index_] = strcpy(new char[strlen(File_) + 1], File_);
}

/******************************************************************************/
void ExamTester::MarkExam()
{
  if (!_Max)
    return;

  int x, y, z, i;
  int Valid_;

  for (x = 0; x < _Sections; x++)
    memset(_SubScore[x], 0, sizeof(int) * 2);
  
  for (_Corrects = i = x = 0; x < _Max; x++)
  {
    y = x * 16;
    Valid_ = 1;

    if (i < _Sections && x == _SectionStart[i])
      i++;
    
    for (z = 0; z < _Parts[x]; z++)
      if (_Answers[y+z] != _Response[y+z])
        Valid_ = 0;

    if (i) _SubScore[i-1][1]++;

    if (Valid_)
    {
      if (i) _SubScore[i-1][0]++;
      _Corrects++;
    }    
  }

  _Score = double(_Corrects) / _Max;
  _Score *= 100;
  _Summary = new char[4096];
  _Summary[0] = 0;

  for (x = 0; x < _Sections; x++)
    sprintf(&_Summary[strlen(_Summary)], "%s: %d/%d\n", _SectionName[x], _SubScore[x][0], _SubScore[x][1]);
  
  sprintf(&_Summary[strlen(_Summary)], "\nYour score is: %d/%d, or %-*.*f", _Corrects, _Max, 5, 1, _Score);
  strcat(_Summary, "%");

#if EXAMTESTER_DEBUG_2
  cout <<_Summary <<endl;
#endif
}

/******************************************************************************/
void ExamTester::ClearResponses()
{
    int x, y;
    for (x = 0; x < _Max; x++)
    {
      y = x * 16;
      _Response[y] = _Response[y+1] = _Response[y+2] = _Response[y+3] =
      _Response[y+4] = _Response[y+5] = _Response[y+6] = _Response[y+7] = ' ';
      _Response[y+8] = _Response[y+9] = _Response[y+10] = _Response[y+11] =
      _Response[y+12] = _Response[y+13] = _Response[y+14] = _Response[y+15] = ' ';
    }
}

/******************************************************************************/
const char* ExamTester::GiveCurrentFile() const
{
  return _CurrentFile;
}

/******************************************************************************/
const char* ExamTester::GiveQuestion(int Index_) const
{
  return _Questions[Index_];
}

/******************************************************************************/
const char* ExamTester::GiveChoices(int Index_) const
{
  return _Choices[Index_];
}

/******************************************************************************/
const char* ExamTester::GiveQGraphic(int Index_) const
{
  return _QGraphicFile[Index_];
}

/******************************************************************************/
const char* ExamTester::GiveAGraphic(int Index_) const
{
  return _AGraphicFile[Index_];
}

/******************************************************************************/
const char* ExamTester::GiveExplanation(int Index_) const
{
  return _Explanations[Index_];
}

/******************************************************************************/
const char* ExamTester::GiveAnswer(int& Index_, int& Parts_) const
{
  Parts_ = _Parts[Index_];
  Index_ *= 16;
  return _Answers;
}

/******************************************************************************/
const char* ExamTester::GiveResponse(int& Index_, int& Parts_) const
{
  Parts_ = _Parts[Index_];
  Index_ *= 16;
  return _Response;
}

/******************************************************************************/
const char* ExamTester::GiveSectionName(int Index_) const
{
  int x;
  for (x = 0; x < _Sections; x++)
    if (Index_ == _SectionStart[x])
      return _SectionName[x];
    else if (Index_ < _SectionStart[x])
      return NULL;

  return NULL;
}

/******************************************************************************/
int ExamTester::MaxQuestions() const
{
  return _Max;
}

/******************************************************************************/
int ExamTester::Sections() const
{
  return _Sections;
}

/******************************************************************************/
int ExamTester::NumCorrect() const
{
  return _Corrects;
}

/******************************************************************************/
int ExamTester::HasErrors() const
{
  return (_Corrects < _Max);
}

/******************************************************************************/
double ExamTester::Score() const
{
  return _Score;
}

/******************************************************************************/
const char* ExamTester::GiveSummary() const
{
  return _Summary;
}

/******************************************************************************/
#if EXAMTESTER_DEBUG
int main()
{
  ExamTester Tester("sattest.txt");
  Tester.SetResponse(0, 'A');
  Tester.SetResponse(1, 'B');
  Tester.SetResponse(2, 'C');
  Tester.SetResponse(3, 'B');
  Tester.SetResponse(4, 'B');
  Tester.SetResponse(5, 'C');
  Tester.SetResponse(6, '8');
  Tester.SetResponse(7, '8', '9');
  Tester.SetResponse(8, '9');
  Tester.MarkExam();
  return 0;
}
#endif
/******************************************************************************/

