#include <fstream>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <ctype.h>

#include "generator.h"

#define EXAMTESTER_DEBUG        0
#define EXAMTESTER_DEBUG_1      0
#define EXAMTESTER_DEBUG_2      0

#define EXAMTESTER_GUI_DEBUG1   0
#define EXAMTESTER_GUI_DEBUG2   0

#define USES_STD                0

#if USES_STD
  #define OSTREAM std::ostream
  #define ISTREAM std::istream
#else
  #define OSTREAM ostream
  #define ISTREAM istream
#endif

using namespace std;

/******************************************************************************/
class ExamTester
{
  private:
    int _Max;
    int _Sections;
    int* _Parts;
    int* _SectionStart;
    int** _SubScore;
    char** _Questions;
    char** _Choices;
    char** _QGraphicFile;
    char** _AGraphicFile;
    char** _Explanations;
    char** _SectionName;
    char* _Answers;
    char* _Response;
    
    int _Corrects;
    double _Score;
    char* _Summary;
    char* _CurrentFile;
    ExamGenerator* _Generator;

    void TestRead();
    void ReadFromFile(const char* ExamFile_, int HtmlFormat_=1);
    void Clear();

  public:
    ExamTester();
    ExamTester(int Max_);
    ExamTester(const char* ExamFile_);
    ~ExamTester();

    void GenerateExam(int Max_);
    void MakeExam(int Max_);
    void ReadFile(const char* ExamFile_);
    void SetChoices(int Index_, char* Choices_);
    void SetQuestion(int Index_, char* Question_);
    void SetQGraphicFile(int Index_, char* File_);
    void SetAGraphicFile(int Index_, char* File_);
    void SetExplanation(int Index_, char* Explain_);
    void SetAnswer(int Index_, char Choice1_, char Choice2_=' ', char Choice3_=' ', char Choice4_=' ',
                   char Choice5_=' ', char Choice6_=' ', char Choice7_=' ', char Choice8_=' ', char* Choicex_=NULL, int Len_=0);
    void SetResponse(int Index_, char Choice1_, char Choice2_=' ', char Choice3_=' ', char Choice4_=' ',
                     char Choice5_=' ', char Choice6_=' ', char Choice7_=' ', char Choice8_=' ', char* Choicex_=NULL, int Len_=0);
    void ClearResponses();    
    void MarkExam();

    const char* GiveCurrentFile() const;
    const char* TutorialFileName(char* Buffer_) const;
    const char* GeneralFileName(char* Buffer_) const;
    const char* NextFileName(char* Buffer_);
    const char* GiveQuestion(int Index_) const;
    const char* GiveChoices(int Index_) const;
    const char* GiveQGraphic(int Index_) const;
    const char* GiveAGraphic(int Index_) const;
    const char* GiveExplanation(int Index_) const;
    const char* GiveAnswer(int& Index_, int& Parts_) const;
    const char* GiveResponse(int& Index_, int& Parts_) const;
    const char* GiveSectionName(int Index_) const;
    const char* GiveSummary() const;
    int MaxQuestions() const;
    int Sections() const;
    int NumCorrect() const;
    int HasErrors() const;
    double Score() const;
    int Fexists(const char* Fname_) const;
};


